unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, SqlExpr, IBCustomDataSet, IBQuery, IBDatabase,
  DBTables, DB, DBClient, Provider, StdCtrls, Buttons, Grids, DBGrids,
  ExtCtrls;

type
  TFrmMain = class(TForm)
    Panel1: TPanel;
    EdtDatabase: TLabeledEdit;
    RadioGroup1: TRadioGroup;
    DBGrid1: TDBGrid;
    Panel2: TPanel;
    DataSetProvider1: TDataSetProvider;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    Database1: TDatabase;
    Query1: TQuery;
    IBTransaction1: TIBTransaction;
    IBDatabase1: TIBDatabase;
    IBQuery1: TIBQuery;
    SQLConnection1: TSQLConnection;
    SQLQuery1: TSQLQuery;
    OpenDialog1: TOpenDialog;
    BtnAlterar: TButton;
    Label2: TLabel;
    MemoSQL: TMemo;
    BtnAbrirFechar: TButton;
    procedure FormCreate(Sender: TObject);
    procedure BtnAbrirFecharClick(Sender: TObject);
    procedure BtnAlterarClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}

// FormCreate
procedure TFrmMain.FormCreate(Sender: TObject);
begin
  EdtDatabase.Text := ExtractFilePath(Application.ExeName) + 'TESTE.FDB';
  RadioGroup1Click(nil);
end;


// BtnAlterarClick
procedure TFrmMain.BtnAlterarClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    EdtDatabase.Text := OpenDialog1.FileName;
end;


// RadioGroup1Click
procedure TFrmMain.RadioGroup1Click(Sender: TObject);
begin
  ClientDataSet1.Close;
end;


procedure TFrmMain.BtnAbrirFecharClick(Sender: TObject);
begin
  ClientDataSet1.Close;
  
  // fecha todas as conexes
  IBDatabase1.Close;
  SQLConnection1.Close;
  Database1.Close;

  // altera a conexo de acordo com a opo escolhida
  if RadioGroup1.ItemIndex = 0 then
    begin
      IBDatabase1.DatabaseName := EdtDatabase.Text;
      IBQuery1.SQL.Text := MemoSQL.Text;
      DataSetProvider1.DataSet := IBQuery1;
    end
  else if RadioGroup1.ItemIndex = 1 then
    begin
      SQLConnection1.Params.Values['Database'] := EdtDatabase.Text;
      SQLQuery1.SQL.Text := MemoSQL.Text;
      DataSetProvider1.DataSet := SQLQuery1;
    end
  else
    begin
      Database1.Params.Values['SERVER NAME'] := EdtDatabase.Text;
      Query1.SQL.Text := MemoSQL.Text;
      DataSetProvider1.DataSet := Query1;
    end;

  // abre o dataset
  ClientDataSet1.Open;
end;




end.
